# Coveo FieldTable Component (CoveoFieldTable)

The FieldTable component displays a set of FieldValue components in a table that can optionally be expandable and minimizable. This component automatically takes care of not displaying empty field values.

This component is a result template component (see Result Templates).

Example:

    // This is the FieldTable component itself, which holds a list of table rows.
    // Each row is a FieldValue component.
    <table class='CoveoFieldTable'>
       // Items
       <tr data-field='@sysdate' data-caption='Date' data-helper='dateTime' />
       <tr data-field='@sysauthor' data-caption='Author' />
       <tr data-field='@clickuri' data-html-value='true' data-caption='URL' data-helper='anchor' data-helper-options='{text: \"<%= raw.syssource %>\" , target:\"_blank\"}'>
    </table>

## Index

### Methods

- debugInfo
- disable
- enable
- expand
- getBindings
- minimize
- toggle
- updateToggleHeight
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- allowMinimization
- expandedTitle
- minimizedByDefault
- minimizedTitle

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### expand

- expand(anim?: boolean): void

- - Defined in ui/FieldTable/FieldTable.ts :166

  Expands (shows) the FieldTable,

  #### Parameters

  - ##### Default value anim: boolean = false

    Specifies whether to show a sliding animation when expanding the FieldTable.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### minimize

- minimize(anim?: boolean): void

- - Defined in ui/FieldTable/FieldTable.ts :180

  Minimizes (collapses) the FieldTable.

  #### Parameters

  - ##### Default value anim: boolean = false

    Specifies whether to show a sliding animation when minimizing the FieldTable.

  #### Returns void

### toggle

- toggle(anim?: boolean): void

- - Defined in ui/FieldTable/FieldTable.ts :158

  Toggles between expanding (showing) and minimizing (collapsing) the FieldTable.

  #### Parameters

  - ##### Default value anim: boolean = false

    Specifies whether to show a sliding animation when toggling the display of the FieldTable.

  #### Returns void

### updateToggleHeight

- updateToggleHeight(): void

- - Defined in ui/FieldTable/FieldTable.ts :194

  Updates the toggle height if the content was dynamically resized, so that the expanding and minimizing animation can match the new content size.

  #### Returns void

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### allowMinimization

allowMinimization: boolean

- Defined in ui/FieldTable/FieldTable.ts :68

Specifies whether to allow the minimization (collapsing) of the FieldTable.

If you set this option to `false`, the component will not create the Minimize / Expand toggle links.

See also FieldTable.options.expandedTitle, FieldTable.options.minimizedTitle and FieldTable.options.minimizedByDefault.

Default value is `true`.

Default

  `true`

Markup configuration example(s) :

    data-allow-minimization='true'
    data-allow-minimization='false'

### expandedTitle

expandedTitle: string

- Defined in ui/FieldTable/FieldTable.ts :76

If FieldTable.options.allowMinimization is `true`, specifies the caption to show on the Minimize link (the link that appears when the FieldTable is expanded).

Default value is `"Details"`.

Only effective when

  `allowMinimization` is truthy

Markup configuration example(s) :

    data-expanded-title='foo'

### minimizedByDefault

minimizedByDefault: boolean

- Defined in ui/FieldTable/FieldTable.ts :98

If FieldTable.options.allowMinimization is `true`, specifies whether to minimize the table by default.

Default value is `undefined`, and the FieldTable will collapse by default if the result it is associated with has a non-empty excerpt.

Only effective when

  `allowMinimization` is truthy

Markup configuration example(s) :

    data-minimized-by-default='true'
    data-minimized-by-default='false'

### minimizedTitle

minimizedTitle: string

- Defined in ui/FieldTable/FieldTable.ts :87

If FieldTable.options.allowMinimization is `true`, specifies the caption to show on the Expand link (the link that appears when the FieldTable is minimized).

Default value is `"Details"`.

Only effective when

  `allowMinimization` is truthy

Markup configuration example(s) :

    data-minimized-title='foo'

## Constructors

### constructor

- new FieldTable(element: HTMLElement, options?: IFieldTableOptions, bindings?: IComponentBindings, result?: IQueryResult): FieldTable

- Overwrites Component.constructor

  - Defined in ui/FieldTable/FieldTable.ts :105

  Creates a new FieldTable.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### Optional options: IFieldTableOptions

    The options for the FieldTable component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  - ##### Optional result: IQueryResult

    The result to associate the component with.

  #### Returns FieldTable